#include <windows.h>
#include <windowsx.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "sbmain.h"
#include "token.h"
#include "main.h"

int sb_end(void);
int sb_print(void);
int sb_input(void);
int sb_goto(void);
int sb_next(int ln,int fnum);
int sb_for(int ln,int fnum);
int sb_endif(int ln);
int sb_else(int ln);
int sb_elseif(int ln);
int sb_if(int ln);
double sb_abs(double x);
double sb_int(double x);
double sb_sqr(double x);
double logic(void);

double expression(void);
double number(void);
double term(void);
double factor(void);
BOOL CALLBACK MyDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp);

extern int for_ln[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};          /* FOR  ̍s */
extern int next_ln[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};         /* NEXT ̍s */
extern int if_flag = -1;         //IF tO
char inbuf[16];

int sb_end(void){
	strcat(opline,"SBasic exit\r\n");
	return 0;
}

int sb_print(void){
	char wsbuf[32];

    while(1){
        get_token();
		if(*token == '"'){        /* 萔 */
			strcat(opline,&token[1]);
            //printf("%s", &token[1]);
		}else if(*token == '\n')   /* Ȃ */
            break;
		else{                       /* vZ */
			sprintf(wsbuf,"%f",logic());
			strcat(opline,wsbuf);
            //printf("%f", logic());
		}

        get_token();
		//ӂ͌񂵂Ƃ
        if(*token == ',')
            printf("\t");           /* TAB \ */
        else if(*token == ';')
            ;                       /* Ȃ */
        else if(*token == '\n')
            break;
        else{
			strcat(opline,"Error : PRINT Grammar Error\r\n");
            //printf("Error : PRINT Grammar Error\n");
            //exit(1); {Ȃ炱ŏIׂ
        }
    }

	strcat(opline,"\r\n");
    //printf("\n");

	return 0;
}

int sb_input(void){
	char val;            /* ϐ(ԍ) */
	char sbuf[64];
	HWND hDlg;

    if(*get_token() == '"'){      /* 萔 */
		strcat(opline,&token[1]);
        if(*get_token() == ',')       //J}
            ;                               //Ȃ
        else if(*token == ';')      //Z~R
			strcat(opline,"? ");	//? ǉ\
        else{
			strcat(opline,"Error : InputGrammarError\r\n");
			return -1;
        }
        val = *get_token();     /* ϐ擾 */
    }else{
        val = *token;           /* ϐ擾 */
		strcat(opline,"? ");	//? \
    }

    if(!isalpha(val)){      /* ϐ`FbN */
		strcat(opline,"HensuuhaEiziitimozi\r\n");
        return -1;
    }
	//L[͂Ȃ΂ȂȂ
	DialogBox(hInst,"MYDLG",GhWnd,(DLGPROC)MyDlgProc);

    hensuu[val - 'A'] = atof(inbuf);   /* ̓f[^ϐ */

	return 0;
}

int sb_if(int ln){
    double      ans;
    int         n;

    if(if_flag != -1){      /* dif̋֎~ */
        printf("IF-ENDIFubN̒IF܂\n");
        exit(1);
    }
    get_token();            /* ̃g[N()擾 */
    ans = logic();          /* ̌vZ */
    if(ans == 1.0)          /*  ^ */
        if_flag = 1;
    else{                   /*  U */
        if_flag = 0;
        /* ESLEIF, ELSE܂ENDIF܂Ŕ΂ */
        for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
            strcpy(gt_line,list[n].string);
            get_token();            /* 擪̃g[N擾 */
            if(!strcmp(token, "ELSEIF") || !strcmp(token, "ELSE") ||
               !strcmp(token, "ENDIF")){
                ln = n - 1;         /* ݍsELSE̍sԍ-1ɐݒ */
                break;
            }
        }
        if(n == last){          /* ŏIs܂ELSEȂ */
            printf("ΉELSEIF, ELSE, ENDIF܂\n");
            exit(1);
        }
    }
    return(ln);
}

int sb_elseif(int ln){
    double      ans;
    int         n;
    
    if(if_flag == -1){      /* IF-ENDIFubNO */
        printf("IF-ENDIFubN̊OELSEIF܂\n");
        exit(1);
    }
    if(if_flag == 1){       /* if,elseif^̎AENDIF܂Ŕ΂ */
        for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
			strcpy(gt_line, list[n].string);
            get_token();                /* 擪̃g[N擾 */
            if(!strcmp(token, "ENDIF")){
                ln = n - 1;             /* ݍsENDIF̍sԍ-1ɐݒ */
                break;
            }
        }
        if(n == last){          /* ŏIs܂ENDIDȂ */
            printf("ΉENDIF܂\n");
            exit(1);
        }
    }else{                  /* U̎A𔻒 */
        get_token();            /* ̃g[N()擾 */
        ans = logic();          /* ̌vZ */
        if(ans == 1.0)          /*  ^ */
            if_flag = 1;
        else{                   /*  U */
            if_flag = 0;
            /* ESLEIF, ELSE܂ENDIF܂Ŕ΂ */
            for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
                strcpy(gt_line, list[n].string);
                get_token();            /* 擪̃g[N擾 */
                if(!strcmp(token, "ELSEIF") || !strcmp(token, "ELSE") ||
                   !strcmp(token, "ENDIF")){
                    ln = n - 1;         /* ݍsELSE̍sԍɐݒ */
                    break;
                }
            }
            if(n == last){          /* ŏIs܂ELSEȂ */
                printf("ΉELSEIF, ELSE, ENDIF܂\n");
                exit(1);
            }
        }
    }
    return(ln);
}

int sb_else(int ln){
    int         n;
    
    if(if_flag == -1){      /* IF-ENDIFubNO */
        printf("IF-ENDIFubN̊OELSE܂\n");
        exit(1);
    }
    if(if_flag == 1){       /* if,elseif^̎AENDIF܂Ŕ΂ */
        for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
			strcpy(gt_line, list[n].string);
            get_token();                /* 擪̃g[N擾 */
            if(!strcmp(token, "ENDIF")){
                ln = n - 1;             /* ݍsENDIF̍sԍ-1ɐݒ */
                break;
            }
        }
        if(n == last){          /* ŏIs܂ENDIDȂ */
            printf("ΉENDIF܂\n");
            exit(1);
        }
    }else                   /* U̎ */
        if_flag = 1;
    return(ln);
}

int sb_endif(int ln){
    if(if_flag == -1){      /* IF-ENDIFubNO */
        printf("IF-ENDIFubN̊OENDIF܂\n");
        exit(1);
    }
    if_flag = -1;
    return(ln);
}

int sb_goto(void){
	get_token();

	return atoi(token);
}

double sb_abs(double x){
	if(x < 0)
		x = x * -1;

	return x;
}

double sb_int(double x){
	double ans;
	ans = floor(x);

	return ans;
}

double sb_sqr(double x){
	x = sqrt(x);
	return x;
}

int sb_for(int ln,int fnum){
    char    val;         /* ϐ(ԍ) */
    double  d1, d2, d3;  /* nl,Il, */
    
    val = *get_token();     /* ϐ擾 */
    if(!isalpha(val)){      /* ϐ`FbN */
        printf("ϐ͉p݂̂ł\n");
        exit(1);
    }

	if(*get_token() != '='){        /* "=" 擾 */
        printf("FOR G[ł(=)\n");
        exit(1);
    }

	get_token();                    //nl擾
    d1 = logic();

	get_token();                    //"TO" 擾
    if(token[0] != 'T' || token[1] != 'O'){
        printf("FOR G[ł(TO)\n");
        exit(1);
    }

    get_token();                    //Il擾
    d2 = logic();

	get_token();                    //"STEP" 擾 
    if(!strcmp(token, "STEP")){     //STEP 
        get_token();                //擾
        d3 = logic();
    }else if(*token == '\n')      //STEP Ȃ
        d3 = 1;
    else{
        printf("FOR G[ł(STEP)\n");
        exit(1);
    }
    
    val = val - 'A';            /* ϐԍvZ */
    if(for_ln[fnum] == -1){         /* PڂFOR */
        for_ln[fnum] = ln;
        hensuu[val] = d1;
    }else{                      /* Qڈȍ~ */
        hensuu[val] = hensuu[val] + d3;                    /* FOR I */
        if(d1 <= d2 && d2 < hensuu[val] || d1 > d2 && d2 > hensuu[val]){
			ln = next_ln[fnum];
            for_ln[fnum] = next_ln[fnum] = -1;
        }
    }
    return ln;
}

int sb_next(int ln,int fnum){
    if(for_ln[fnum] == -1){
        printf("Ή FOR ܂\n");
        exit(1);
    }
    next_ln[fnum] = ln;
    ln = for_ln[fnum] - 1;

    return ln;
}


double expression(void){
    double  ans;

    ans = term();
    while(1){
        if(*token == '+'){
            strcpy(token, &token[1]);
            if(*token == '\0')
                get_token();
            ans = ans + term();
        }else if(*token == '-'){
            strcpy(token, &token[1]);
            if(*token == '\0')
                get_token();
            ans = ans - term();
        }else
            break;
    }
    unget_token(token);

    return(ans);
}

double logic(void){
    double  ans;

    ans = expression();
    get_token();

    while(1){
        if(*token == '<'){          /* <>,<=,< */
            get_token();
            if(*token == '='){          /* ȉ */
                get_token();
                if(ans <= expression())
                    ans = 1;
                else
                    ans = 0;
            }else if(*token == '>'){    /* Ȃ */
                get_token();
                if(ans != expression())
                    ans = 1;
                else
                    ans = 0;
            }else{                      /* 菬 */
                if(ans < expression())
                    ans = 1;
                else
                    ans = 0;
            }
        }else if(*token == '>'){    /* >=,> */
            get_token();
            if(*token == '='){          /* ȏ */
                get_token();
                if(ans >= expression())
                    ans = 1;
                else
                    ans = 0;
            }else{                      /* 傫 */
                if(ans > expression())
                    ans = 1;
                else
                    ans = 0;
            }
        }else if(*token == '='){    /*  */
            get_token();
            if(ans == expression())
                ans = 1;
            else
                ans = 0;
        }else
            break;
    }

    unget_token(token);
    
	return ans;
}

double term(void){
    double  ans, x;

    ans = factor();
    while(1){
        if(*token == '*'){
            get_token();
            ans = ans * factor();
        }else if(*token == '/'){
            get_token();
            x = factor();
			if(x == 0){                
				strcat(opline,"0ł͊Ȃ\n");
			}
            ans = ans / x;
        }else
            break;
    }

    return(ans);
}

double factor(void)
{
    double  ans;

    if(*token == '('){
        get_token();
        ans = expression();
        get_token();
        if(*token != ')'){
            //printf(")Ȃ\n");
			strcat(opline,")Ȃ\n");
            //exit(1);
        }
        get_token();
        return(ans);
    }else
        return(number());
}

double number(void){
    double  ans = 0;
    char    sign = NULL;

    if(*token == '+' || *token == '-'){     /*  */
        sign = *token;
        strcpy(token, &token[1]);
        if(*token == '\0')
            get_token();
    }

    if(isalpha(*token))         /* 擪p */
        ans = hensuu[toupper(*token) - 'A'];    /* ϐ̓e擾 toupperc̊֐ */
    else if(isdigit(*token))    /* 擪 */
        ans = atof(token);          /* lɕϊ */
    else
		strcat(opline,"Error F:number\n");

    get_token();
	if(sign == '-'){
		ans = ans * -1;
        return ans;
	}

    return ans;
}



BOOL CALLBACK MyDlgProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp){
    static HWND hParent;

	switch (msg) {
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDOK:
					GetDlgItemText(hDlg,IDC_OUTPUT,inbuf,(int)sizeof(inbuf) -1);
                    EndDialog(hDlg, IDOK);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}