#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <ctype.h>
#include <wchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "stdafx.h"
#include "SBasic.h"
#include "sbmain.h"
#include "token.h"
#include "resource.h"


int sb_end(void);
int sb_print(void);
int sb_input(void);
int sb_goto(void);
int sb_next(int ln,int fnum);
int sb_for(int ln,int fnum);
int sb_endif(int ln);
int sb_else(int ln);
int sb_elseif(int ln);
int sb_if(int ln);
double sb_abs(double x);
double sb_int(double x);
double sb_sqr(double x);
double logic(void);

double expression(void);
double number(void);
double term(void);
double factor(void);

extern int for_ln[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};          /* FOR  ̍s */
extern int next_ln[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};         /* NEXT ̍s */
extern int if_flag = -1;         //IF tO
TCHAR inbuf[16];
extern int input_flag = 0;

int sb_end(void){
	_tcscat(opline,_T("SBasic exit\r\n"));
	return 0;
}

int sb_print(void){
	TCHAR wsbuf[32];

    while(1){
        get_token();
		if(*token == '"'){        /* 萔 */
			_tcscat(opline,&token[1]); 
		}else if(*token == '\n')   /* Ȃ */
            break;
		else{                       /* vZ */
			_sntprintf(wsbuf,32,_T("%f"),logic());
			_tcscat(opline,wsbuf);
		}

        get_token();
		//ӂ͌񂵂Ƃ
        if(*token == ',')
            ;
        else if(*token == ';')
            ;                       /* Ȃ */
        else if(*token == '\n')	//""\r\n"ȂȁH
            break;
        else{
			MessageBox(GhWnd,_T("Error : PRINT Grammar Error"),_T("Error"),MB_OK);
            return -1;
        }
    }

	_tcscat(opline,_T("\r\n"));

	return 0;
}

int sb_input(void){
	static TCHAR val;            /* ϐ(ԍ) */

	if(input_flag == 0){
		if(*get_token() == '"'){      /* 萔 */
			_tcscat(opline,&token[1]);
			if(*get_token() == ',')      //J}
				;                               //Ȃ
			else if(*token == ';')      //Z~R
				_tcscat(opline,_T("?"));	//? ǉ\
			else
				MessageBox(GhWnd,_T("Error : InputGrammarError"),_T("Error"),MB_OK);
				return -1;
			val = *get_token();     /* ϐ擾 */
		}else{
			val = *token;           /* ϐ擾 */
			_tcscat(opline,_T("?"));	//? \
		}

		if(!isalpha(val)){      /* ϐ`FbN */
			MessageBox(GhWnd,_T("HensuuhaEiiziitimozi"),_T("Error"),MB_OK);
			return -1;
		}
		input_flag = 1;
		SetFocus(hInput);
	}else if(input_flag == 1){
		hensuu[val - 'A'] = _ttoi(inbuf);   /* ̓f[^ϐ */
		_tcscat(opline,inbuf);
		_tcscat(opline,_T("\r\n"));

		input_flag = 0;
	}

	return 0;
}

int sb_if(int ln){
    double      ans;
    int         n;

    if(if_flag != -1){      /* dif̋֎~ */
		MessageBox(GhWnd,_T("IF ERROR"),_T("Error"),MB_OK);
        return -1;
    }
    get_token();            /* ̃g[N()擾 */
    ans = logic();          /* ̌vZ */
    if(ans == 1.0)          /*  ^ */
        if_flag = 1;
    else{                   /*  U */
        if_flag = 0;
        /* ESLEIF, ELSE܂ENDIF܂Ŕ΂ */
        for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
            wcscpy(gt_line,list[n].string);
            get_token();            /* 擪̃g[N擾 */
            if(!wcscmp(token,_T("ELSEIF")) || !wcscmp(token, _T("ELSE")) ||
               !wcscmp(token,_T("ENDIF"))){
                ln = n - 1;         /* ݍsELSE̍sԍ-1ɐݒ */
                break;
            }
        }
        if(n == last){          /* ŏIs܂ELSEȂ */
			MessageBox(GhWnd,_T("Not found else and so on"),_T("Error"),MB_OK);
            return -1;
        }
    }
    return(ln);
}

int sb_elseif(int ln){
    double      ans;
    int         n;
    
    if(if_flag == -1){      /* IF-ENDIFubNO */
		MessageBox(GhWnd,_T("E:sb_elseif"),_T("Error"),MB_OK);
        return -1;
    }
    if(if_flag == 1){       /* if,elseif^̎AENDIF܂Ŕ΂ */
        for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
			wcscpy(gt_line, list[n].string);
            get_token();                /* 擪̃g[N擾 */
            if(!wcscmp(token,_T("ENDIF"))){
                ln = n - 1;             /* ݍsENDIF̍sԍ-1ɐݒ */
                break;
            }
        }
        if(n == last){          /* ŏIs܂ENDIDȂ */
			MessageBox(GhWnd,_T("E:sbelseif"),_T("Error"),MB_OK);
            return -1;
        }
    }else{                  /* U̎A𔻒 */
        get_token();            /* ̃g[N()擾 */
        ans = logic();          /* ̌vZ */
        if(ans == 1.0)          /*  ^ */
            if_flag = 1;
        else{                   /*  U */
            if_flag = 0;
            /* ESLEIF, ELSE܂ENDIF܂Ŕ΂ */
            for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
                wcscpy(gt_line, list[n].string);
                get_token();            /* 擪̃g[N擾 */
                if(!wcscmp(token,_T("ELSEIF")) || !wcscmp(token,_T("ELSE")) ||
                   !wcscmp(token,_T("ENDIF"))){
                    ln = n - 1;         /* ݍsELSE̍sԍɐݒ */
                    break;
                }
            }
            if(n == last){          /* ŏIs܂ELSEȂ */
				MessageBox(GhWnd,_T("E:sb_elseif"),_T("Error"),MB_OK);
                return -1;
            }
        }
    }
    return(ln);
}

int sb_else(int ln){
    int         n;
    
    if(if_flag == -1){      /* IF-ENDIFubNO */
		MessageBox(GhWnd,_T("E:sb_else"),_T("Error"),MB_OK);
        return -1;
    }
    if(if_flag == 1){       /* if,elseif^̎AENDIF܂Ŕ΂ */
        for(n = ln + 1; n < last; ++n){     /* ̍sŏIs܂Œׂ */
			wcscpy(gt_line, list[n].string);
            get_token();                /* 擪̃g[N擾 */
            if(!wcscmp(token,_T("ENDIF"))){
                ln = n - 1;             /* ݍsENDIF̍sԍ-1ɐݒ */
                break;
            }
        }
        if(n == last){          /* ŏIs܂ENDIDȂ */
			MessageBox(GhWnd,_T("sb_else"),_T("Error"),MB_OK);
            return -1;
        }
    }else                   /* U̎ */
        if_flag = 1;
    return(ln);
}

int sb_endif(int ln){
    if(if_flag == -1){      /* IF-ENDIFubNO */
		MessageBox(GhWnd,_T("sb_endif"),_T("Error"),MB_OK);
        return -1;
    }
    if_flag = -1;
    return(ln);
}

int sb_goto(void){
	get_token();

	return _ttoi(token);
}

double sb_abs(double x){
	if(x < 0)
		x = x * -1;

	return x;
}

double sb_int(double x){
	double ans;
	ans = floor(x);

	return ans;
}

double sb_sqr(double x){
	x = sqrt(x);

	return x;
}

int sb_for(int ln,int fnum){
    TCHAR    val;         /* ϐ(ԍ) */
    double  d1, d2, d3;  /* nl,Il, */
    
    val = *get_token();     /* ϐ擾 */
    if(!isalpha(val)){      /* ϐ`FbN */
		MessageBox(GhWnd,_T("sb_for"),_T("Error"),MB_OK);
		return -1;
    }

	if(*get_token() != '='){        /* "=" 擾 */
		MessageBox(GhWnd,_T("sb_for"),_T("Error"),MB_OK);
        return -1;
    }

	get_token();                    //nl擾
    d1 = logic();

	get_token();                    //"TO" 擾
    if(token[0] != 'T' || token[1] != 'O'){
		MessageBox(GhWnd,_T("sb_for"),_T("Error"),MB_OK);
		return -1;
    }

    get_token();                    //Il擾
    d2 = logic();

	get_token();                    //"STEP" 擾 
    if(!wcscmp(token,_T("STEP"))){     //STEP 
        get_token();                //擾
        d3 = logic();
    }else if(*token == '\r\n')      //STEP Ȃ
        d3 = 1;
    else{
        MessageBox(GhWnd,_T("sb_for"),_T("Error"),MB_OK);
        return -1;
    }
    
    val = val - 'A';            /* ϐԍvZ */
    if(for_ln[fnum] == -1){         /* PڂFOR */
        for_ln[fnum] = ln;
        hensuu[val] = d1;
    }else{                      /* Qڈȍ~ */
        hensuu[val] = hensuu[val] + d3;                    /* FOR I */
        if(d1 <= d2 && d2 < hensuu[val] || d1 > d2 && d2 > hensuu[val]){
			ln = next_ln[fnum];
            for_ln[fnum] = next_ln[fnum] = -1;
        }
    }
    return ln;
}

int sb_next(int ln,int fnum){
    if(for_ln[fnum] == -1){
		MessageBox(GhWnd,_T("sb_next"),_T("Error"),MB_OK);
        return -1;
    }
    next_ln[fnum] = ln;
    ln = for_ln[fnum] - 1;

    return ln;
}


double expression(void){
    double  ans;

    ans = term();
    while(1){
        if(*token == '+'){
            wcscpy(token, &token[1]);
            if(*token == '\0')
                get_token();
            ans = ans + term();
        }else if(*token == '-'){
            wcscpy(token, &token[1]);
            if(*token == '\0')
                get_token();
            ans = ans - term();
        }else
            break;
    }
    unget_token(token);

    return(ans);
}

double logic(void){
    double  ans;

    ans = expression();
    get_token();

    while(1){
        if(*token == '<'){          /* <>,<=,< */
            get_token();
            if(*token == '='){          /* ȉ */
                get_token();
                if(ans <= expression())
                    ans = 1;
                else
                    ans = 0;
            }else if(*token == '>'){    /* Ȃ */
                get_token();
                if(ans != expression())
                    ans = 1;
                else
                    ans = 0;
            }else{                      /* 菬 */
                if(ans < expression())
                    ans = 1;
                else
                    ans = 0;
            }
        }else if(*token == '>'){    /* >=,> */
            get_token();
            if(*token == '='){          /* ȏ */
                get_token();
                if(ans >= expression())
                    ans = 1;
                else
                    ans = 0;
            }else{                      /* 傫 */
                if(ans > expression())
                    ans = 1;
                else
                    ans = 0;
            }
        }else if(*token == '='){    /*  */
            get_token();
            if(ans == expression())
                ans = 1;
            else
                ans = 0;
        }else
            break;
    }

    unget_token(token);
    
	return ans;
}

double term(void){
    double  ans, x;

    ans = factor();
    while(1){
        if(*token == '*'){
            get_token();
            ans = ans * factor();
        }else if(*token == '/'){
            get_token();
            x = factor();
            if(x == 0)
				MessageBox(GhWnd,_T("E:term"),_T("Error"),MB_OK);
            ans = ans / x;
        }else
            break;
    }

    return(ans);
}

double factor(void)
{
    double  ans;

    if(*token == '('){
        get_token();
        ans = expression();
        get_token();
        if(*token != ')'){
			MessageBox(GhWnd,_T("E:factor"),_T("Error"),MB_OK);
            return -1;
        }
        get_token();
        return(ans);
    }else
        return(number());
}

double number(void){
    double  ans;
    TCHAR    sign = NULL;

    if(*token == '+' || *token == '-'){     /*  */
        sign = *token;
        wcscpy(token, &token[1]);
        if(*token == '\0')
            get_token();
    }

    if(isalpha(*token))         /* 擪p */
        ans = hensuu[toupper(*token) - 'A'];    /* ϐ̓e擾 toupperc̊֐ */
    else if(isdigit(*token))    /* 擪 */
        ans = _ttoi(token);          /* lɕϊ */

    get_token();
	if(sign == '-'){
		ans = ans * -1;
        return(ans);
	}

    return(ans);
}
