#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include "main.h"
#include "file.h"
#include "sbmain.h"
//eXgp
#include "sb_function.h"

#define ID_EDIT	100
#define ID_OUTPUT	101

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);

HINSTANCE hInst;
HWND hEdit,hOutPut,GhWnd;
char szClassName[] = "SBasic";	//EBhENX
char szTitle[128] = "SBasic";
char *szTitle_org = "SBasic[%s](%doCg)";
char szFile[MAX_PATH] = "de.txt";
char szFileTitle[MAX_PATH];
char opline[1024]="\0";

int WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst,LPSTR lpsCmdLine, int nCmdShow)
{
	MSG msg;
	BOOL bRet;
	
	if (!InitApp(hCurInst))
		return FALSE;
	if (!InitInstance(hCurInst, nCmdShow)) 
		return FALSE;
	while((bRet = GetMessage(&msg, NULL, 0, 0)) != 0){
		if(bRet == -1){
			break;
		}else{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int)msg.wParam;
}

ATOM InitApp(HINSTANCE hInst){
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;	//vV[W
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;//CX^X
	wc.hIcon = (HICON)LoadImage(NULL,
		MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON,0,0,
		LR_DEFAULTSIZE | LR_SHARED);
	wc.hCursor = (HCURSOR)LoadImage(NULL,
		MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR,0,0,
		LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = "MYMENU";	//j[
	wc.lpszClassName = (LPCSTR)szClassName;
	wc.hIconSm = (HICON)LoadImage(NULL,
		MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON,0,0,
		LR_DEFAULTSIZE | LR_SHARED);

	return (RegisterClassEx(&wc));
}

BOOL InitInstance(HINSTANCE hInst, int nCmdShow){
	HWND hWnd;

	hWnd = CreateWindow(szClassName,
			"SBasic",WS_VISIBLE | WS_SYSMENU, //EBhE̎
			CW_USEDEFAULT,CW_USEDEFAULT,	//X,xW
			480,320,
			NULL,NULL,
			hInst, //CX^Xnh
			NULL);
	if (!hWnd)
		return FALSE;
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){
	int id;

	GhWnd = hWnd;	//_CAOŎgp邽߂ɃO[oϐɓĂ

	switch (msg) {
		case WM_CREATE:
			//GfB^̈̍쐬
			hEdit = CreateWindow("EDIT",NULL,WS_CHILD | WS_VISIBLE | ES_WANTRETURN | ES_MULTILINE | ES_AUTOVSCROLL | WS_VSCROLL | ES_UPPERCASE,
			0,0,480,200,hWnd,(HMENU)ID_EDIT,hInst,NULL);
			strcat(szTitle,"[NameLess]");
			SetWindowText(hWnd,szTitle);
			Edit_LimitText(hEdit,0);

			hOutPut = CreateWindow("EDIT",NULL,WS_CHILD | WS_VISIBLE | ES_WANTRETURN | ES_MULTILINE | ES_AUTOVSCROLL | WS_VSCROLL | ES_UPPERCASE | ES_READONLY,
			0,200,480,80,hWnd,(HMENU)ID_OUTPUT,hInst,NULL);
			Edit_LimitText(hOutPut,0);
			break;
		case WM_COMMAND:
			switch(LOWORD(wp)){
				case IDM_NEW:
					NewFile(hEdit);
					break;
				case IDM_OPEN:
					OpenFile(hEdit);
					break;
				case IDM_SAVE:
					SaveFile(hEdit);
					break;
				case IDM_SAVEAS:
					SaveFileAs(hEdit);
					break;
				case IDM_END:
					SendMessage(hWnd,WM_CLOSE,0,0);
					break;
				case IDM_DO:
					sbmain();
					SetWindowText(hOutPut,opline);
					break;
			}
			break;
		case WM_CLOSE:
			id = MessageBox(hWnd,"END?","end",
				MB_YESNO | MB_ICONQUESTION);
			if (id == IDYES)
				DestroyWindow(hWnd);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return (DefWindowProc(hWnd,msg,wp,lp));
	}
	return 0;
}