#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <windows.h>
#include <windowsx.h>
#include "sbmain.h"
#include "sb_function.h"
#include "token.h"
#include "main.h"

/*-----------------------------*/
#define SB_END	1
#define SB_PRINT	2
#define	SB_INPUT	3
#define SB_GOTO	4
#define SB_ABS	5
#define SB_INT	6
#define SB_SQR	7
#define SB_LET	8
#define SB_FOR	9
#define SB_NEXT	10
#define SB_IF	11
#define SB_ELSEIF	12
#define SB_ELSE	13
#define SB_ENDIF	14
#define SB_DAINYU	15

/* O[oϐ */
struct line list[200];
char gt_line[STR_MAX];   /* get_token()p1sf[^obt@ */
char token[STR_MAX];     /* 擾g[N */
double hensuu[26];
int now = 0;        /* sJEg */
int last;           /* ŏIs */
int fornow=0;

/* vg^Cv錾 */
int classification(void);			//߂𔻒肷
int sbasicMain(int cmd);
int enclnton(int ln);
int dofunction(void);
int readFile(void);

int sbmain(void){
	if(now==0)
		readFile();	//t@C̓ǂݍ
	
	strcpy(gt_line,list[now].string);     //͂̏
	if(dofunction() == 0){
		strcpy(gt_line,list[now].string);
	}
		
	get_token(); //g[N̎擾
	if(sbasicMain(classification()) == -1){
		MessageBox(hEdit,"Error'sbmain'","SBasic",MB_ICONEXCLAMATION | MB_OK);
		return -1;
	}

	now++;

	//ڂɌď
	if(now == last){
		now=0;
		return 1;
	}

	return 0;
}


int readFile(void){
	FILE *fp;            //t@C|C^
	int count=0;
    
	if((fp = fopen(szFile,"r")) == NULL){      //t@CI[v
        strcat(opline,"ErrorCan'tStart\r\n");
		MessageBox(GhWnd,"st@CJ܂","SBasic",MB_ICONEXCLAMATION | MB_OK);
		return -1;
    }

    //t@C̓ǂݍ
    while(fgets(gt_line,256,fp) != NULL){        //1sǂݍ
		get_token();
		list[count].blnum = atoi(token);
		list[count].string = (char *)malloc(strlen(gt_line) + 1);
		if(list[count].string == NULL){
			strcat(opline,"Can't SecureMem\r\n");
			MessageBox(GhWnd,"̈mۂɎs܂ in sbmain()","SBasic",MB_ICONEXCLAMATION | MB_OK);
            return -1;
        }
		strcpy(list[count].string,gt_line);
        count++;
    }

	//t@C̃N[Y
    fclose(fp);

	last = count;

	return 0;
}

int dofunction(void){
	double alta;
	int cmd;
	char buf[STR_MAX]={};
	char itizi[16];

	do{
		get_token();
		if((cmd = classification()) == SB_INT){
			get_token();
			alta = logic();
			alta = sb_int(alta);
			sprintf(itizi,"%f",alta);
			strcat(buf,itizi);
			strcpy(gt_line,buf);
			return 1;
		}else if(cmd == SB_ABS){
			get_token();
			alta = logic();
			alta = sb_abs(alta);
			sprintf(itizi,"%f",alta);
			strcat(buf,itizi);
			strcpy(gt_line,buf);
			return 1;
		}else if(cmd == SB_SQR){
			get_token();
			alta = logic();
			alta = sb_sqr(alta);
			sprintf(itizi,"%f",alta);
			strcat(buf,itizi);
			strcpy(gt_line,buf);
			return 1;
		}else{
			strcat(buf,token);
		}
	}while(token[0] != '\0');

	return 0;
}

int sbasicMain(int cmd){
	int valnum;

	switch (cmd) {
		case SB_END:
			sb_end();
			break;
		case SB_PRINT:
			if(sb_print() == -1){
				strcat(opline,"ErrorPrint\r\n");
				return -1;}
			break;
		case SB_INPUT:
			if(sb_input() == -1){
				strcat(opline,"ErrorInput\r\n");
				return -1;
			}
			break;
		case SB_FOR:
			now = sb_for(now,fornow);
			break;
		case SB_NEXT:
			now = sb_next(now,fornow);
			break;
		case SB_IF:
			now = sb_if(now);
			break;
		case SB_ELSEIF:
			now = sb_elseif(now);
			break;
		case SB_ELSE:
			now = sb_else(now);
			break;
		case SB_ENDIF:
			now = sb_endif(now);
			break;
		case SB_GOTO:
			now = enclnton(sb_goto()) - 1;//Ȃ-1Ƃ܂
			//-1闝Rmain֐for[vɂĂ̊֐ICNg邩
			break;
		case SB_LET:
			get_token();
			valnum = *token - 'A';      /* ϐԍL */
            get_token();
            if(*token != '='){
				strcat(opline,"LetError\r\n");
                //printf("LetError\n");
            }
            get_token();
            hensuu[valnum] = logic();  /* vZ */
			break;
		case SB_DAINYU:
			valnum = *token - 'A';      /* ϐԍL */
            get_token();
            if(*token != '='){
				strcat(opline,"ErrorDainyu\r\n");
                //printf("ErrorDAINYU\n");
                exit(1);
            }
            get_token();
            hensuu[valnum] = logic();  /* vZ */
			break;
		default :
			strcat(opline,"ErrorDefault\r\n");
			//printf("ERROR\n");
			return -1;
			break;
	}

	return 0;
}

int classification(void){
	if(!strcmp("PRINT",token)){
		return SB_PRINT;
	}else if(!strcmp("INPUT",token)){
		return SB_INPUT;
	}else if(!strcmp("END",token)){
		return SB_END;
	}else if(!strcmp("GOTO",token)){
		return SB_GOTO;
	}else if(!strcmp("ABS",token)){
		return SB_ABS;
	}else if(!strcmp("SQR",token)){
		return SB_SQR;
	}else if(!strcmp("INT",token)){
		return SB_INT;
	}else if(!strcmp("FOR",token)){
		return SB_FOR;
	}else if(!strcmp("NEXT",token)){
		return SB_NEXT;
	}else if(!strcmp("IF",token)){
		return SB_IF;
	}else if(!strcmp("ELSEIF",token)){
		return SB_ELSEIF;
	}else if(!strcmp("ELSE",token)){
		return SB_ELSE;
	}else if(!strcmp("ENDIF",token)){
		return SB_ENDIF;
	}else if(!strcmp("LET",token)){	//͍Ōɔ肵ȂƐꍇƌ邩AłΉĂ悤
		return SB_LET;
	}else if(isalpha(*token)){	//͍Ōɔ肵ȂƐꍇƌ邩AłΉĂ悤
		return SB_DAINYU;
	}
	return -1;
}



int enclnton(int ln){
	int i;

	for(i = 0;i < last;i++){
		if(list[i].blnum == ln)
			return i;
	}

	printf("GOTO Error\n");
	exit(1);

	return 0;
}